/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner{}

// CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner struct for CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner
type CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner struct {
	Lang *string `json:"lang,omitempty"`
	Value *string `json:"value,omitempty"`
	SupportingMedia []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner `json:"supportingMedia,omitempty"`
}

// NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner instantiates a new CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner() *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner {
	this := CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner{}
	return &this
}

// NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerWithDefaults instantiates a new CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerWithDefaults() *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner {
	this := CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner{}
	return &this
}

// GetLang returns the Lang field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) GetLang() string {
	if o == nil || IsNil(o.Lang) {
		var ret string
		return ret
	}
	return *o.Lang
}

// GetLangOk returns a tuple with the Lang field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) GetLangOk() (*string, bool) {
	if o == nil || IsNil(o.Lang) {
		return nil, false
	}
	return o.Lang, true
}

// HasLang returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) HasLang() bool {
	if o != nil && !IsNil(o.Lang) {
		return true
	}

	return false
}

// SetLang gets a reference to the given string and assigns it to the Lang field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) SetLang(v string) {
	o.Lang = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) SetValue(v string) {
	o.Value = &v
}

// GetSupportingMedia returns the SupportingMedia field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) GetSupportingMedia() []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner {
	if o == nil || IsNil(o.SupportingMedia) {
		var ret []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner
		return ret
	}
	return o.SupportingMedia
}

// GetSupportingMediaOk returns a tuple with the SupportingMedia field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) GetSupportingMediaOk() ([]CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner, bool) {
	if o == nil || IsNil(o.SupportingMedia) {
		return nil, false
	}
	return o.SupportingMedia, true
}

// HasSupportingMedia returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) HasSupportingMedia() bool {
	if o != nil && !IsNil(o.SupportingMedia) {
		return true
	}

	return false
}

// SetSupportingMedia gets a reference to the given []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner and assigns it to the SupportingMedia field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) SetSupportingMedia(v []CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) {
	o.SupportingMedia = v
}

func (o CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Lang) {
		toSerialize["lang"] = o.Lang
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	if !IsNil(o.SupportingMedia) {
		toSerialize["supportingMedia"] = o.SupportingMedia
	}
	return toSerialize, nil
}

type NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner struct {
	value *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner
	isSet bool
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) Get() *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner {
	return v.value
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) Set(val *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner(val *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner {
	return &NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner{value: val, isSet: true}
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


